import 'dart:mirrors';

import 'package:librus_api/src/misc/activator.dart';

abstract class Serializable {
  Map toJson() {
    Map map = new Map();
    InstanceMirror im = reflect(this);
    ClassMirror cm = im.type;
    var decls = cm.declarations.values
        .where((dm) => dm is VariableMirror)
        .where((dm) => !dm.isPrivate)
        .where((dm) => !im.type.staticMembers.keys.contains(dm.simpleName));
    decls.forEach((item) => print(MirrorSystem.getName(item.simpleName)));
    decls.forEach((dm) {
      var key = MirrorSystem.getName(dm.simpleName);
      var val = im.getField(dm.simpleName).reflectee;
      map[key] = val;
    });

    return map;
  }
}
