import 'package:librus_api/src/account.dart';
import 'package:librus_api/src/models/category.dart';
import 'package:librus_api/src/models/grade.dart';
import 'package:librus_api/src/models/subject.dart';

Future<List<Subject>> fetchSubjects(Account account) async {
  List<Subject> subjects = await account.fetch<Subject>();
  List<Grade> grades = await account.fetch<Grade>();
  List<Category> categories = await account.fetch<Category>();
  grades = account.bind<Grade, Subject>(grades, subjects, "subject");
  grades = account.bind<Grade, Category>(grades, categories, "category");
  grades.forEach((Grade grade) {
    subjects.forEach((Subject subject) {
      if(grade.subject == subject) {
        subject.grades.add(grade);
      }
    });
  });
  return subjects;
}
